Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.ka2ddo.yaac.util
Class CheckpointingLogger

    java.lang.Object
      java.io.OutputStream
          org.ka2ddo.yaac.util.CheckpointingLogger

All Implemented Interfaces:
  java.io.Closeable, java.io.Flushable

    public class CheckpointingLogger

extends java.io.OutputStream

This class defines a rolling logger that checkpoints the last N bytes of a log file to a disk file.

Constructor Summary
`CheckpointingLogger(int bufSize, java.io.File logFile)` Create a CheckpointingLogger stream with the specified maximum file size and path to the file.

Method Summary
`void` | `close()` Closes this output stream and releases any system resources associated with this stream.
`void` | `flush()` Flushes this output stream and forces any buffered output bytes to be written out.
`int` | `getFileLength()` Get the last-written size of the log file.
`int` | `getLength()` Get the current position in the buffer for the next character to write (may be end of buffer).
`java.lang.String` | `getLoggerContents()` Get the current contents of the logger's buffer.
`java.lang.String` | `getLogPathName()` Report the pathname of the file where this logger will checkpoint the log data.
`int` | `getMaxSize()` Return the maximum number of bytes this logger can hold.
`void` | `write(byte[] b, int off, int len)` Writes `len` bytes from the specified byte array starting at offset `off` to this output stream.
`void` | `write(int b)` Writes the specified byte to this output stream.

Methods inherited from class java.io.OutputStream
`write`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### CheckpointingLogger

    public CheckpointingLogger(int bufSize,
                               java.io.File logFile)

  Create a CheckpointingLogger stream with the specified maximum file size and path to the file.

  Parameters:
    `bufSize` - int maximum file size in bytes
    `logFile` - File pointing to where the data should be checkpointed

Method Detail

### close

    public void close()
               throws java.io.IOException

  Closes this output stream and releases any system resources associated with this stream. The general contract of `close` is that it closes the output stream. A closed stream cannot perform output operations and cannot be reopened.

  Specified by:
    `close` in interface `java.io.Closeable`
  Overrides:
    `close` in class `java.io.OutputStream`
  Throws:
    `java.io.IOException` - if an I/O error occurs.

### write

    public void write(byte[] b,
                      int off,
                      int len)
               throws java.io.IOException

  Writes `len` bytes from the specified byte array starting at offset `off` to this output stream. The general contract for `write(b, off, len)` is that some of the bytes in the array `b` are written to the output stream in order; element `b[off]` is the first byte written and `b[off+len-1]` is the last byte written by this operation.

  If `b` is `null`, a `NullPointerException` is thrown.

  If `off` is negative, or `len` is negative, or `off+len` is greater than the length of the array `b`, then an `IndexOutOfBoundsException` is thrown.

  Overrides:
    `write` in class `java.io.OutputStream`
  Parameters:
    `b` - the data.
    `off` - the start offset in the data.
    `len` - the number of bytes to write.
  Throws:
    `java.io.IOException` - if an I/O error occurs. In particular, an `IOException` is thrown if the output stream is closed.

### write

    public void write(int b)
               throws java.io.IOException

  Writes the specified byte to this output stream. The general contract for `write` is that one byte is written to the output stream. The byte to be written is the eight low-order bits of the argument `b`. The 24 high-order bits of `b` are ignored.

  Specified by:
    `write` in class `java.io.OutputStream`
  Parameters:
    `b` - the `byte`.
  Throws:
    `java.io.IOException` - if an I/O error occurs. In particular, an `IOException` may be thrown if the output stream has been closed.

### flush

    public void flush()
               throws java.io.IOException

  Flushes this output stream and forces any buffered output bytes to be written out. The general contract of `flush` is that calling it is an indication that, if any bytes previously written have been buffered by the implementation of the output stream, such bytes should immediately be written to their intended destination.

  If the intended destination of this stream is an abstraction provided by the underlying operating system, for example a file, then flushing the stream guarantees only that bytes previously written to the stream are passed to the operating system for writing; it does not guarantee that they are actually written to a physical device such as a disk drive.

  Specified by:
    `flush` in interface `java.io.Flushable`
  Overrides:
    `flush` in class `java.io.OutputStream`
  Throws:
    `java.io.IOException` - if an I/O error occurs.

### getLogPathName

    public java.lang.String getLogPathName()

  Report the pathname of the file where this logger will checkpoint the log data.

  Returns:
    absolute pathname of log file

### getLoggerContents

    public java.lang.String getLoggerContents()

  Get the current contents of the logger's buffer.

  Returns:
    the String contents of the log buffer

### getFileLength

    public int getFileLength()

  Get the last-written size of the log file.

  Returns:
    file size in bytes

### getLength

    public int getLength()

  Get the current position in the buffer for the next character to write (may be end of buffer).

  Returns:
    current length of buffer contents

### getMaxSize

    public int getMaxSize()

  Return the maximum number of bytes this logger can hold.

  Returns:
    byte size of logger's buffer

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD